-- constants
local st_startup = 1	-- the startup before we go spinning
local st_spin = 2	-- the harrassment spin
local st_burst = 3	-- the wind burst that damages

local st_divecircle = 4	-- looping with a circle
local st_diveoval = 5	-- looping with an oval back to the start point
local st_divebomb = 6	-- the actual divebomb
local st_diveimpact = 7	-- when we impact the ground

Ray.GLIDETUMBLETICS = TICRATE*2/3
Ray.GLIDETUMBLEHEIGHT = FRACUNIT*8

Ray.TORNADONAME = "Mach Tornado"
Ray.TORNADOCOST = 10
Ray.TORNADOCOOLDOWN = TICRATE*7/2

Ray.TORNADOSTARTUPTICS = TICRATE*2/3
Ray.TORNADOSTARTUPROTATE = 16
Ray.TORNADOSTARTUPXYMULTIPLIER = FRACUNIT*96/100
Ray.TORNADOSTARTUPZMULTIPLIER = FRACUNIT*92/100

Ray.TORNADOTICS = TICRATE*9/5
Ray.TORNADOMINTICS = FixedMul(FRACUNIT/8, Ray.TORNADOTICS)
Ray.TORNADOCHARGETICS = FixedMul(FRACUNIT*7/9, Ray.TORNADOTICS)
Ray.TORNADOSPEEDMULTIPLER = FRACUNIT*43/40	-- speed up!
Ray.TORNADOMAXTHRUSTFACTORMULTIPLIER = FRACUNIT*6	-- can help us changing direction
Ray.TORNADORISE = FRACUNIT*6/5
Ray.TORNADORISEMULTIPLIER = FRACUNIT/2	-- for holding neutral
Ray.TORNADORISETHRESHOLD = FRACUNIT*15/2
Ray.TORNADOROTATE = 96

Ray.TORNADOCOLLIDETUMBLE = TICRATE*4/5
Ray.TORNADOCOLLIDEHEIGHT = FRACUNIT*9

Ray.TORNADOPUSHBACKSCALAR = FRACUNIT*4/9
Ray.TORNADOPUSHBACK = FRACUNIT*26

Ray.TORNADOMINBURSTHEIGHT, Ray.TORNADOMAXBURSTHEIGHT = FRACUNIT*7/2, FRACUNIT*8
Ray.TORNADOBURSTHEIGHT = FRACUNIT*6
Ray.TORNADOBURSTHEIGHTMULTIPLIER = FRACUNIT/2
Ray.TORNADOBURSTSMEARTICS = 2
Ray.TORNADOBURSTTICS = TICRATE*2/3

Ray.TORNADOHITBOXTICS = TICRATE/5
Ray.TORNADOMINRANGE, Ray.TORNADOMAXRANGE = FRACUNIT*80, FRACUNIT*120
Ray.TORNADOMINHEIGHT, Ray.TORNADOMAXHEIGHT = FRACUNIT*96, FRACUNIT*128	-- this is NOT centered

Ray.DIVENAME = "Dive Bomb"
Ray.DIVECOST = 10
Ray.DIVECOOLDOWN = TICRATE*2

Ray.DIVESPEEDDIVIDER = FRACUNIT*4/3	-- how much our speed will get cut
Ray.DIVEMINSPEED = FRACUNIT*28	-- minimum speed
Ray.DIVELOOPSCALAR = FRACUNIT*7/2	-- how big the loop will be depending on our speed

Ray.DIVEWAVEMULTIPLIER = FRACUNIT*10
Ray.DIVEWAVEFADEMULTIPLIER = FRACUNIT/2
Ray.DIVEDUSTMULTIPLIER = FRACUNIT*4
Ray.DIVEDUSTSCALEMULTIPLIER = FRACUNIT/3
Ray.DIVEDUSTTHRUSTMULTIPLIER = FRACUNIT/3

Ray.DIVESPLATTICS = TICRATE/3
Ray.DIVEREBOUNDMULTIPLIER = FRACUNIT/4
Ray.DIVEREBOUNDCUTMULTIPLIER = FRACUNIT*2/3

Ray.DIVESPIKEMULTIPLIER = FRACUNIT*4/5	-- reduce our OWN momentum, just a tad
-- these will stay updated with chaotixchars mighty, just for future proofing!
Ray.DIVESPIKEBOUNCES = 3
Ray.DIVESPIKEMODIFIER = FRACUNIT/6
Ray.DIVESPIKEMAXTICS = TICRATE*8

// sounds

freeslot("sfx_raybmb", "sfx_rayslm", "sfx_rayspn", "sfx_raybur")
sfxinfo[sfx_raybmb].caption = "Dive Bomb"
sfxinfo[sfx_rayslm].caption = "Slam"
sfxinfo[sfx_rayspn].caption = "Spinning"
sfxinfo[sfx_raybur].caption = "Wind Burst"

// states
freeslot("S_RAY_TORNADO", "S_RAY_TORNADO_FAST", "S_RAY_TORNADO_BURST")
states[S_RAY_TORNADO] = {SPR_PLAY, A|SPR2_MLEE, -1, nil, 0, 0, S_RAY_TORNADO}
states[S_RAY_TORNADO_FAST] = {SPR_PLAY, A|SPR2_TWIN, -1, nil, 0, 0, S_RAY_TORNADO_FAST}
states[S_RAY_TORNADO_BURST] = {SPR_PLAY, A|SPR2_MLEL, -1, nil, 0, 0, S_RAY_TORNADO_BURST}

freeslot("S_RAY_DIVEBOMB_LOOP", "S_RAY_DIVEBOMB", "S_RAY_DIVEBOMB_IMPACT")
function A_RayDiveBombLoop(actor, var1, var2)
	local p = actor.player
	if not ((p and p.valid) and p.actionstate) then return end	-- the code relies on this
	
	-- get frame based on zangle
	local zangle_work = 360 - actor.ray_battle_zangle
	local frame
	if (p.actionstate == st_divecircle)
		frame = max(A, F - ((zangle_work * F) / 135))
	elseif (p.actionstate == st_diveoval)
		frame = max(F, K - ((zangle_work * K) / 180))
	end
	if (frame == nil) then return end
	
	-- set frame
	actor.frame = ($ &~ FF_FRAMEMASK) | frame
end
states[S_RAY_DIVEBOMB_LOOP] = {SPR_PLAY, A|SPR2_FLY_, 1, A_RayDivebombLoop, 0, 0, S_RAY_DIVEBOMB_LOOP}
states[S_RAY_DIVEBOMB] = {SPR_PLAY, A|SPR2_TIRE, 2, nil, 0, 0, S_RAY_DIVEBOMB}
states[S_RAY_DIVEBOMB_IMPACT] = {SPR_PLAY, SPR2_TAL6, -1, nil, 0, 0, S_RAY_DIVEBOMB_IMPACT}
if not _G["sfx_hamspk"]
	freeslot("sfx_hamspk")
	sfxinfo[sfx_hamspk].caption = "METEOR SMASH"
end

-- ray's tornado hitbox
freeslot("S_RAY_TORNADO_HITBOX", "MT_RAY_TORNADO_HITBOX")
states[S_RAY_TORNADO_HITBOX] = {SPR_NULL, 0, Ray.TORNADOHITBOXTICS, nil, 0, 0, S_NULL}
mobjinfo[MT_RAY_TORNADO_HITBOX] = {
	spawnstate = S_RAY_TORNADO_HITBOX,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT,
}
Ray.cv_showhitbox = CV_RegisterVar({
	name = "rayshowhitbox",
	defaultvalue = "No",
	flags = CV_NETVAR,
	PossibleValue = CV_YesNo,
})
Ray.TornadoRadialDamage = function(hitbox)
	local range = hitbox.ray_range
	local height = hitbox.ray_height
	if not (range and height) then return end
	
	-- setup hitbox table
	hitbox.ray_hitmobjs = $ or {}
	
	-- search with blockmap
	local source = hitbox.target
	searchBlockmap("objects", function(ref, found)
		if not ((found and found.valid) and found.health) then return end
		if (ref == found) then return end	-- don't damage the inflictor
		if (found == source) then return end	-- don't damage the source!
		
		-- already hit!
		if (ref.ray_hitmobjs[found]) then return end
		
		-- valid type?
		if not ((found.flags & (MF_SHOOTABLE|MF_ENEMY|MF_MONITOR)) or found.player)
			return
		end
		
		-- player checks
		if (found.player)
			if (found.player.spectator) then return end	-- NUH UH
			if not (CBW_Battle.PlayerCanBeDamaged(found.player)) then return end	-- cant be damaged
		end
		
		-- positional checks
		local dist = R_PointToDist2(ref.x, ref.y, found.x, found.y)
		if not (dist <= range) then return end	-- making it radial
		
		local bottomz = ref.z - (height / 2)
		local topz = ref.z + (height / 2)
		if not ((topz >= found.z) and (bottomz <= found.z + found.height)) then return end	-- z checks
		
		if not (P_CheckSight(ref, found)) then return end
		
		-- damage them!
		P_DamageMobj(found, source, source)
		ref.ray_hitmobjs[found] = true
	end, hitbox, hitbox.x - range, hitbox.x + range, hitbox.y - range, hitbox.y + range)
end

Ray.SpawnTornadoHitbox = function(mo, range, height)
	if not (mo and mo.valid) then return end	-- need a source
	if not (range or height) then return end	-- needs a range and height
	local tics = Ray.TORNADOHITBOXTICS
	
	-- the actual damage range
	local hitbox = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_RAY_TORNADO_HITBOX)
	hitbox.target = mo
	hitbox.tics = tics
	hitbox.ray_range = FixedMul(mo.scale, range)
	hitbox.ray_height = FixedMul(mo.scale, height)
	
	-- do the radial check instantly
	Ray.TornadoRadialDamage(hitbox)
	
	-- show range (debug)
	if (Ray.cv_showhitbox.value)
		//hitbox.sprite = SPR_THOK
		//hitbox.color = SKINCOLOR_WHITE
		
		local angle_thoks = 15
		for angle_i = 1, angle_thoks
			local angle = ((360 / angle_thoks) * angle_i) * ANG1
				
			local length_thoks = 5
			for length_i = 0, length_thoks - 1
				local dist_modifier = (FRACUNIT / (length_thoks - 1)) * length_i
				local xoff = FixedMul(FixedMul(dist_modifier, range), cos(angle))
				local yoff = FixedMul(FixedMul(dist_modifier, range), sin(angle))
				
				local height_thoks = 3
				for height_i = 0, height_thoks - 1
					-- STOP DRAWING
					if not (height_i == (height_thoks - 1))
					and not (length_i == (length_thoks - 1))
						continue
					end
					
					-- nvm draw
					local height_modifier = (FRACUNIT / (height_thoks - 1)) * height_i
					local zoff = FixedMul(height_modifier, height / 2)
					
					-- draw first thok
					local thok = P_SpawnMobjFromMobj(mo, xoff, yoff, (mo.height/2) + zoff, MT_THOK)
					thok.frame = ($ & ~(FF_TRANSMASK)) | (FF_FULLBRIGHT|FF_TRANS70)
					thok.scale = FixedMul(FRACUNIT/3, $)
					thok.color = SKINCOLOR_WHITE
					thok.tics = tics
					
					-- draw another one, mirrored
					if (zoff)
						zoff = -$	-- flip it
						
						local thok2 = P_SpawnMobjFromMobj(mo, xoff, yoff, (mo.height/2) + zoff, MT_THOK)
						thok2.frame = ($ & ~(FF_TRANSMASK)) | (FF_FULLBRIGHT|FF_TRANS70)
						thok2.scale = FixedMul(FRACUNIT/3, $)
						thok2.color = SKINCOLOR_WHITE
						thok2.tics = tics
					end
				end
			end
		end
	end
end
addHook("MobjThinker", function(hitbox)
	-- make sure it's a valid explosion
	local source = hitbox.target
	local range = hitbox.ray_range
	local height = hitbox.ray_height
	
	if not (source and source.valid)	-- no source???
	or not (range and height)	-- no range or height?
		P_RemoveMobj(hitbox)
		return
	end
	
	-- damage stuff
	Ray.TornadoRadialDamage(hitbox)
end, MT_RAY_TORNADO_HITBOX)

-- whirlwind
function A_RayWhirlwindThink(actor, var1, var2)
	local mo = actor.target
	local p = mo and mo.valid and mo.player
	if not (Ray.IsRay(p)
	and p.actionstate >= st_startup and p.actionstate <= st_spin)
		P_RemoveMobj(actor)
		return
	end
	
	actor.movecount = $ + 1
	actor.frame = (actor.movecount/var2) % (var1 + 1)
	A_CapeChase(actor)
end
freeslot("SPR_RAYX", "S_RAY_WHIRLWIND")
states[S_RAY_WHIRLWIND] = {SPR_RAYX, A, 1, A_RayWhirlwindThink, D, 1, S_RAY_WHIRLWIND}

-- shockwave
Ray.SetShockwaveTransparency = function(shockwave)
	-- fade out with fuse
	local painchance = mobjinfo[MT_RAY_SHOCKWAVE].painchance
	local fade_tics = FixedMul(Ray.DIVEWAVEFADEMULTIPLIER, mobjinfo[MT_RAY_SHOCKWAVE].painchance)
	if (shockwave.fuse <= fade_tics)
		local trans = ((shockwave.fuse + 1) * 10) / fade_tics
		if (trans >= 1 and trans <= 9)
			shockwave.frame = $|(trans << FF_TRANSSHIFT)
		end
	end
	-- shrink
	if not shockwave.cusval
		shockwave.spriteyscale = max($ - FRACUNIT/painchance/2, 1)
	end
end
function A_RayShockwaveThink(actor, var1, var2)
	if (actor.hnext)
		A_Boss3ShockThink(actor, var1, var2)
	end
	Ray.SetShockwaveTransparency(actor)
end
freeslot("S_RAY_SHOCKWAVE", "MT_RAY_SHOCKWAVE")
states[S_RAY_SHOCKWAVE] = {SPR_RAYX, FF_ADD|FF_PAPERSPRITE|FF_FULLBRIGHT|E, 1, A_RayShockwaveThink, 0, 0, S_RAY_SHOCKWAVE}
mobjinfo[MT_RAY_SHOCKWAVE] = {
	spawnstate = S_RAY_SHOCKWAVE,
	radius = FRACUNIT*48,
	height = FRACUNIT*8,
	speed = FRACUNIT*64,	-- doesnt really matter
	damage = 3,
	painchance = TICRATE/3,	-- also controls speed
	seesound = sfx_rayslm,
	flags = MF_NOBLOCKMAP|MF_MISSILE|MF_NOGRAVITY|MF_PAPERCOLLISION
}

-- add battle functions
local loaded = false
addHook("ThinkFrame", do
	if not (CBW_Battle) then return end	-- battle isnt loaded
	if (loaded) then return end	-- already setup for battle? dont run
	local B = CBW_Battle
	local S = B.SkinVars
	
	-- priority
	local function ray_battlePriority(p)
		local mo = p.mo
		
		-- mach tornado
		if (p.actionstate >= st_startup and p.actionstate <= st_burst)
			local def = (p.actionstate == st_spin) and 2 or 0
			B.SetPriority(p, 0, def, "knuckles_glide", 0, def, "mach tornado")
			return
		end
		
		-- gliding
		if (mo.state == S_PLAY_GLIDE)
		or (p.actionstate >= st_divecircle and p.actionstate <= st_divebomb)
			-- set stuff
			local atk, def = 0, 0
			local satk, sdef = 0, 0
			local hurttxt = (p.actionstate == st_divebomb) and "dive bomb" or "skin flaps"
			
			if (p.actionstate == st_divebomb)
			or (p.actionstate >= st_divecircle and p.actionstate <= st_diveoval)
				-- easy check
				atk, def = 1, 1
				satk, sdef = 2, 1
			else
				-- speed lines need to be here
				local thrust = mo.rayglidestorethrust
				local runspeed = FixedMul(p.runspeed, mo.scale)*3/2
				if (thrust and (thrust > runspeed))
					atk = 1
					satk, sdef = 2, 1
				end
			end
			
			local priority_func = "knuckles_glide"
			if (p.actionstate >= st_divecircle and p.actionstate <= st_divebomb)
				-- dude i dont feel like doing angle math
				local momz = mo.momz * P_MobjFlip(mo)
				priority_func = (momz < 0) and "fang_tailbounce" or "tails_fly"
			end
			
			-- set priority
			B.SetPriority(p, atk, def, priority_func, satk, sdef, hurttxt)
			
			-- reset attack after storing it, we just want to tumble and not damage with the glide
			if (hurttxt == "skin flaps")	-- SKIN FLAPS DONT HURT
				mo.ray_battle_atk = p.battle_atk
				mo.ray_battle_satk = p.battle_satk
				p.battle_atk = 0
				p.battle_satk = 0
			end
			
			return
		end
	end
	
	-- ray's special
	local function ray_machTornado(mo, doaction)
		local p = mo.player
		
		-- state functions
		if (p.actionstate >= st_startup and p.actionstate <= st_spin)
			p.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
			p.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_WALL|STR_CEILING
			
			-- spawn in dust (probably the hackiest way to do this)
			local ray = P_SpawnMobjFromMobj(mo, 0,0,0, MT_RAY)
			ray.radius = mo.radius*2
			ray.height = mo.height*4/3
			ray.target = mo
			A_CapeChase(ray)
			A_BossScream(ray, 3, p.actionstate == st_startup and MT_DUST or MT_SPINDUST)
			P_RemoveMobj(ray)
			
			if (p.actionstate == st_startup)	-- starting up the tornado
				-- set state and frame
				local state = S_RAY_TORNADO
				if (mo.state != state) then mo.state = state end
					
				-- start rotating
				local angle_add = ease.inquart((p.actiontime * FRACUNIT) / Ray.TORNADOSTARTUPTICS, Ray.TORNADOSTARTUPROTATE, Ray.TORNADOROTATE)
				mo.ray_battle_angle = $ + (angle_add * ANG1)
				p.drawangle = mo.ray_battle_angle
				
				-- adjust stuff
				mo.flags = $|(MF_NOGRAVITY)
				mo.ray_fixstuff = true	-- we'll need this
					
				-- no guarding
				p.canguard = false
					
				-- change actionstate
				if (p.actiontime >= Ray.TORNADOSTARTUPTICS)
					p.actionstate = st_spin
					p.actiontime = 0	-- reset this
					mo.state = S_RAY_TORNADO_FAST
					mo.ray_battle_charge = 0
					
					local thok = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
					thok.target = mo
					thok.state = S_RAY_WHIRLWIND
				else
					-- slow down
					local xy_multiplier = Ray.TORNADOSTARTUPXYMULTIPLIER
					mo.momx = FixedMul(xy_multiplier, $)
					mo.momy = FixedMul(xy_multiplier, $)
					mo.momz = FixedMul(Ray.TORNADOSTARTUPZMULTIPLIER, $)
				end
			elseif (p.actionstate == st_spin)	-- speeeeen
				-- set state and frame
				local state = S_RAY_TORNADO_FAST
				if (mo.state != state) then mo.state = state end
				
				-- change actionstate
				if (p.actiontime >= Ray.TORNADOTICS)
				or ((p.actiontime >= Ray.TORNADOMINTICS) and not doaction)
					local charge = min(Ray.TORNADOCHARGETICS, p.actiontime)
					local easing = (charge * FRACUNIT) / Ray.TORNADOCHARGETICS
					
					-- burst hitbox
					local range = ease.linear(easing, Ray.TORNADOMINRANGE, Ray.TORNADOMAXRANGE)
					local height = ease.linear(easing, Ray.TORNADOMINHEIGHT, Ray.TORNADOMAXHEIGHT)
					Ray.SpawnTornadoHitbox(mo, FRACUNIT*120, FRACUNIT*128)
					
					S_StopSoundByID(mo, sfx_rayspn)
					S_StartSound(mo, sfx_raybur)
					
					-- burst animation
					local burst_height = ease.linear(easing, Ray.TORNADOMINBURSTHEIGHT, Ray.TORNADOMAXBURSTHEIGHT) * P_MobjFlip(mo)
					burst_height = $ / B.WaterFactor(mo)
					mo.state = S_RAY_TORNADO_BURST
					mo.flags = $ & ~(MF_NOGRAVITY)
					mo.momz = FixedMul(Ray.TORNADOBURSTHEIGHTMULTIPLIER, $) + burst_height
						
					local momz = mo.momz * P_MobjFlip(mo)
					if (momz < burst_height)
						mo.momz = burst_height * P_MobjFlip(mo)
					end
					
					-- create shockwave effect
					local angle = p.cmd.angleturn << 16
					local thrust = FRACUNIT*120 / mobjinfo[MT_RAY_SHOCKWAVE].painchance
					thrust = FixedMul($, mo.scale)
					for i = 1, 8
						local shockangle = i * ANGLE_45
						local thok = P_SpawnMobjFromMobj(mo,
						0, 0, p.height*2/5, MT_THOK)
						
						thok.angle = angle - ANGLE_90
						thok.rollangle = shockangle - ANGLE_90
						
						P_InstaThrust(thok, thok.angle,
						P_ReturnThrustX(mo, shockangle, thrust))
						thok.momz = P_ReturnThrustY(mo, shockangle, thrust)
						
						thok.spritexscale = FRACUNIT*8/9
						thok.spriteyscale = thok.spritexscale
						
						thok.cusval = 1
						thok.fuse = mobjinfo[MT_RAY_SHOCKWAVE].painchance
						thok.state = S_RAY_SHOCKWAVE
						
						for j = 1, 4
							P_RailThinker(thok)
							if not (thok and thok.valid) then break end
						end
					end
					
					-- set actionstate
					p.actionstate = st_burst
					p.actiontime = 0	-- reset this
					p.exhaustmeter = FRACUNIT
					p.canguard = true
					B.ApplyCooldown(p, Ray.TORNADOCOOLDOWN)
					
					-- fix stuff
					p.normalspeed = skins[mo.skin].normalspeed
					p.thrustfactor = skins[mo.skin].thrustfactor
					mo.flags = $ & ~(MF_NOGRAVITY|MF_BOUNCE)
					mo.ray_fixstuff = nil	-- not needed anymore
				else
					-- adjust thrustfactor
					local normalspeed = FixedMul(Ray.TORNADOSPEEDMULTIPLER, skins[mo.skin].normalspeed)
					
					local controlangle = (p.cmd.angleturn << 16) + R_PointToAngle2(0, 0, p.cmd.forwardmove * FRACUNIT, -(p.cmd.sidemove * FRACUNIT))
					local angle = R_PointToAngle2(0, 0, mo.momx, mo.momy) - controlangle
					local anglefactor = cos(angle)
					local anglespeed = FixedDiv(FixedMul(anglefactor, FixedHypot(mo.momx, mo.momy)), mo.scale)
					
					local maxthrustspeed = normalspeed * 2
					local thrustspeed = anglespeed + normalspeed
					local thrustfactor_multiplier = ease.linear(FixedDiv(thrustspeed, maxthrustspeed), Ray.TORNADOMAXTHRUSTFACTORMULTIPLIER)
					thrustfactor_multiplier = FRACUNIT + (Ray.TORNADOMAXTHRUSTFACTORMULTIPLIER - $)
					local thrustfactor = FixedMul(thrustfactor_multiplier, skins[mo.skin].thrustfactor << FRACBITS) >> FRACBITS
					
					p.normalspeed = normalspeed
					p.thrustfactor = thrustfactor
					mo.flags = $|(MF_NOGRAVITY|MF_BOUNCE)
					mo.ray_fixstuff = true	-- we'll need this
					
					-- no guarding
					p.canguard = false
						
					-- rotate
					local angle_add = Ray.TORNADOROTATE
					mo.ray_battle_angle = $ + (angle_add * ANG1)
					p.drawangle = mo.ray_battle_angle
						
					-- rise or lower
					if (P_IsObjectOnGround(mo))
						mo.z = $ + P_MobjFlip(mo)
					end
					
					local momz = FixedDiv(mo.momz, mo.scale) * P_MobjFlip(mo)
					local rise = FixedMul(mo.scale, Ray.TORNADORISE) / B.WaterFactor(mo)
						
					local direction = 0
					if (p.cmd.buttons & BT_JUMP) then direction = $+1 end
					if (p.cmd.buttons & BT_SPIN) then direction = $-1 end
					
					if (direction)
						local threshold = Ray.TORNADORISETHRESHOLD / B.WaterFactor(mo)
						if (direction > 0)	-- ascending
							-- ascend (but dont go past the speed cap)
							if (momz < threshold)
								local threshold = FixedMul(mo.scale, threshold)
								mo.momz = min(threshold, $ + rise)
							end
						else	-- descending
							-- descend (but dont go past the speed cap)
							threshold = $ * -1	-- inverse this
							if (momz > threshold)
								threshold = FixedMul(mo.scale, $)
								mo.momz = max(threshold, $ - rise)
							end
						end
					else
						-- normalize z momentum
						rise = FixedMul(Ray.TORNADORISEMULTIPLIER, $)
						if (momz > 0)	-- we gotta lower
							mo.momz = max(0, $ - rise)
						elseif (momz < 0)	-- we gotta rise
							mo.momz = min(0, $ + rise)
						end
					end
					
					-- charge text
					local chargetext = min(100, (p.actiontime * 100) / Ray.TORNADOCHARGETICS)
					p.action2text = "Charge "..chargetext.."%"
					p.action2textflags = (chargetext == 100 and (leveltime&4 <= 2)) and 2 or 0	-- TF_YELLOW = 2 (these arent exposed)
					
					-- exhaust
					p.exhaustmeter = max(0, FRACUNIT - ((p.actiontime * FRACUNIT) / Ray.TORNADOTICS))
				end
			end
		elseif (p.actionstate == st_burst)	-- release and attack nearby players!
			-- set state and frame
			local state = S_RAY_TORNADO_BURST
			if (mo.state != state) then mo.state = state end
			
			local frame = (p.actiontime > Ray.TORNADOBURSTSMEARTICS) and 1 or 0
			mo.frame = ($ &~ FF_FRAMEMASK) | frame
				
			-- change actionstate
			p.canguard = true
			if (p.actiontime >= Ray.TORNADOBURSTTICS)
			or (P_IsObjectOnGround(mo))	-- cancel!
				-- reset action state
				p.actionstate = 0
				
				-- set player state
				mo.state = S_PLAY_FALL
				if (P_IsObjectOnGround(mo)) 
					Ray.TriggerLandingLag(p)
				else
					p.pflags = ($|PF_THOKKED) & ~(PF_JUMPED)
				end
			end
		end
	end
	
	/* this function saved my life
	local function ray_drawCircle(color, x, y, z, radius, hangle, xyscalar, zscalar)
		xyscalar = $ or FRACUNIT
		zscalar = $ or FRACUNIT
		
		-- draw the centre
		local centre = P_SpawnMobj(x, y, z, MT_THOK)
		centre.color = color
		centre.tics = 2
		
		-- draw the circumference
		local cthoks = 16
		for i = 1, cthoks
			local zangle = (360 / cthoks) * i * ANG1
			
			local xpos = centre.x + FixedMul(FixedMul(zscalar, sin(zangle)), FixedMul(FixedMul(xyscalar, cos(hangle)), radius))
			local ypos = centre.y + FixedMul(FixedMul(zscalar, sin(zangle)), FixedMul(FixedMul(xyscalar, sin(hangle)), radius))
			local zpos = centre.z + FixedMul(FixedMul(zscalar, cos(zangle)), radius)
			
			local cthok = P_SpawnMobj(xpos, ypos, zpos, MT_THOK)
			cthok.color = color
			cthok.scale = $/2
			cthok.tics = 2
		end
	end*/
	
	local function ray_diveBomb(mo)
		local p = mo.player
		
		if (p.actionstate >= st_divecircle and p.actionstate <= st_diveoval)
			-- set state and frame
			local state = S_RAY_DIVEBOMB_LOOP
			if (mo.state != state) then mo.state = state end
				
			/*local start = P_SpawnMobj(mo.ray_battle_start.x, mo.ray_battle_start.y, mo.ray_battle_start.z, MT_THOK)
			start.color = SKINCOLOR_YELLOW
			start.tics = 2*/
			
			local circle = mo.ray_battle_circle
			//ray_drawCircle(SKINCOLOR_RED, circle.x, circle.y, circle.z, circle.radius, mo.ray_battle_hangle)
			
			p.actiontime = $ + 1
			p.powers[pw_strong] = STR_ANIM|STR_ATTACK|STR_BUST|STR_HEAVY
			
			if (p.actionstate == st_divecircle)	-- looping to the oval point
				local targ_zangle = (mo.ray_battle_zangle + (360 / circle.loopspeed)) % 360 + 1	-- loop around
				
				if (targ_zangle < mo.ray_battle_zangle)
					-- create an oval to follow
					p.actionstate = st_diveoval

					local circle_startx = circle.x + FixedMul(cos(mo.ray_battle_hangle), circle.radius)
					local circle_starty = circle.y + FixedMul(sin(mo.ray_battle_hangle), circle.radius)
					local radius = R_PointToDist2(circle_startx, circle_starty, mo.ray_battle_start.x, mo.ray_battle_start.y) / 2	-- XY radius
					
					-- calculating the circumference of ovals is ASS
					local xyscalar = FixedDiv(radius, circle.radius)
					local multiplier = (xyscalar + FRACUNIT) / 2	-- assume original circle scalar is 1x
					local circumference = FixedMul(multiplier, circle.circumference)
					
					mo.ray_battle_oval = {
						xyscalar = FixedDiv(radius, circle.radius),	-- we'll multiply circle.radius's scalar
						loopspeed = FixedMul(FixedDiv(circumference, mo.ray_battle_speed), TICRATE) / TICRATE,	-- how long it takes to loop the circumference
						x = mo.ray_battle_start.x + FixedMul(cos(mo.ray_battle_hangle), radius),
						y = mo.ray_battle_start.y + FixedMul(sin(mo.ray_battle_hangle), radius),
						z = circle.z,
					}
					local oval = mo.ray_battle_oval
					
					-- start following it (offset ahead by 180)
					local oval_hdist = R_PointToDist2(mo.x, mo.y, oval.x, oval.y)
					local oval_zdist = oval.z - mo.z
					
					local targ_zangle = R_PointToAngle2(0, 0, oval_hdist, oval_zdist)
					targ_zangle = (Ray.AngToInt($) + (360 / oval.loopspeed)) % 360 + 1
					local targ_x = oval.x + FixedMul(cos((targ_zangle) * ANG1), FixedMul(cos(mo.ray_battle_hangle), radius))
					local targ_y = oval.y + FixedMul(cos((targ_zangle) * ANG1), FixedMul(sin(mo.ray_battle_hangle), radius))
					local targ_z = oval.z + FixedMul(sin((targ_zangle) * ANG1), radius)
					
					mo.momx = targ_x - mo.x
					mo.momy = targ_y - mo.y
					mo.momz = targ_z - mo.z
					mo.ray_battle_zangle = targ_zangle + 180
				else	-- continue looping
					local targ_x = circle.x + FixedMul(cos((targ_zangle) * ANG1), FixedMul(cos(mo.ray_battle_hangle), circle.radius))
					local targ_y = circle.y + FixedMul(cos((targ_zangle) * ANG1), FixedMul(sin(mo.ray_battle_hangle), circle.radius))
					local targ_z = circle.z + FixedMul(sin((targ_zangle) * ANG1), circle.radius)
					
					mo.momx = targ_x - mo.x
					mo.momy = targ_y - mo.y
					mo.momz = targ_z - mo.z
					mo.ray_battle_zangle = targ_zangle	-- compare again next tic
				end
			elseif (p.actionstate == st_diveoval)	-- looping to the start point
				local oval = mo.ray_battle_oval
				//ray_drawCircle(SKINCOLOR_BLUE, oval.x, oval.y, oval.z, circle.radius, mo.ray_battle_hangle, oval.xyscalar)
				
				local targ_zangle = (mo.ray_battle_zangle + (360 / oval.loopspeed)) % 360 + 1	-- loop around
				if (targ_zangle < mo.ray_battle_zangle)
					-- start the dive bomb
					p.actionstate = st_divebomb
					
					-- meet up with the line
					local adjacent = R_PointToDist2(mo.x, mo.y, mo.ray_battle_start.x, mo.ray_battle_start.y)
					local zangle = acos(FixedDiv(adjacent, mo.ray_battle_speed))
					
					local targ_x = mo.x + FixedMul(cos(zangle), FixedMul(cos(mo.ray_battle_hangle), mo.ray_battle_speed))
					local targ_y = mo.y + FixedMul(cos(zangle), FixedMul(sin(mo.ray_battle_hangle), mo.ray_battle_speed))
					local targ_z = mo.z + FixedMul(sin(zangle), mo.ray_battle_speed)
					
					mo.momx = targ_x - mo.x
					mo.momy = targ_y - mo.y
					mo.momz = -(targ_z - mo.z)	-- this goes in the wrong direction, just gonna inverse it because i DONT WANNA DO MORE MATHS
					
					-- store this for the next state
					mo.ray_battle_prevmomz = mo.momz	-- store this
				else	-- continue looping
					targ_zangle = $ - 180	-- remove check offset
					
					local targ_x = oval.x + FixedMul(cos((targ_zangle) * ANG1), FixedMul(FixedMul(oval.xyscalar, cos(mo.ray_battle_hangle)), circle.radius))
					local targ_y = oval.y + FixedMul(cos((targ_zangle) * ANG1), FixedMul(FixedMul(oval.xyscalar, sin(mo.ray_battle_hangle)), circle.radius))
					local targ_z = oval.z + FixedMul(sin((targ_zangle) * ANG1), circle.radius)
					
					mo.momx = targ_x - mo.x
					mo.momy = targ_y - mo.y
					mo.momz = targ_z - mo.z
					mo.ray_battle_zangle = targ_zangle + 180	-- add back the offset to compare
				end
			end
		elseif (p.actionstate == st_divebomb)
			-- impact!
			if (P_IsObjectOnGround(mo))
				-- damaging shockwave
				local distance = FixedMul(Ray.DIVEWAVEMULTIPLIER, abs(mo.ray_battle_prevmomz))
				local old_speed = mobjinfo[MT_RAY_SHOCKWAVE].speed
				mobjinfo[MT_RAY_SHOCKWAVE].speed = distance / mobjinfo[MT_RAY_SHOCKWAVE].painchance
				A_Shockwave(mo, MT_RAY_SHOCKWAVE, 24)
				mobjinfo[MT_RAY_SHOCKWAVE].speed = old_speed
				
				B.ApplyCooldown(p, Ray.DIVECOOLDOWN)
				S_StopSoundByID(mo, sfx_raybmb)
				
				-- radial dust for visuals
				local dusts = 16	-- technically spawns two times the amount
				local dust_speed = FixedMul(Ray.DIVEDUSTMULTIPLIER, abs(mo.ray_battle_prevmomz))
				local angle_diff = 360/dusts
				
				for i = 1, dusts
					local angle_rotation = (angle_diff * i) * ANG1
					for j = 0, 1
						local angle = ((angle_diff/2) * j * ANG1) + angle_rotation
						local xoff = FixedMul(cos(angle), FRACUNIT*24)
						local yoff = FixedMul(sin(angle), FRACUNIT*24)
						
						local dust = P_SpawnMobjFromMobj(mo, xoff, yoff, 0, MT_SPINDUST)
						dust.scale = $*3/2
						dust.scale = $ - (FixedMul(Ray.DIVEDUSTSCALEMULTIPLIER, dust.scale) * j)
						dust.destscale = 1
						dust.scalespeed = dust.scale / 18
						
						-- thrust the dust forward
						local dust_multiplier = FRACUNIT - (Ray.DIVEDUSTTHRUSTMULTIPLIER * (1 - j))
						local dust_thrust = FixedMul(mo.scale, FixedMul(dust_multiplier, dust_speed))
						P_Thrust(dust, angle, dust_thrust)
					end
				end
				
				-- set actionstate
				p.pflags = $|(PF_FULLSTASIS)
				p.actionstate = st_diveimpact
				p.actiontime = 0
				mo.state = S_RAY_DIVEBOMB_IMPACT
				//B.ResetPlayerProperties(p)
				
				/*
				P_KillMobj(mo)
				mo.momx, mo.momy, mo.momz = 0, 0, 0
				mo.h_impact = 0
				mo.v_impact = 0
				mo.impact_speed = 0*/
				return
			end
			
			-- set state and frame
			local state = S_RAY_DIVEBOMB
			if (mo.state != state) then mo.state = state end
			
			-- straight down!
			mo.momx, mo.momy = 0, 0
			mo.ray_battle_prevmomz = mo.momz	-- store this
			p.powers[pw_strong] = STR_BOUNCE|STR_HEAVY
		elseif (p.actionstate == st_diveimpact)
			-- set state and frame
			local state = S_RAY_DIVEBOMB_IMPACT
			if (mo.state != state) then mo.state = state end
			
			-- un-splat
			if (p.actiontime >= Ray.DIVESPLATTICS)
				-- rebound upwards depending on old momentum
				
				S_StartSound(mo, sfx_cdfm50)
				mo.state = S_PLAY_SPRING
				mo.momz = FixedMul(Ray.DIVEREBOUNDMULTIPLIER, -(mo.ray_battle_prevmomz))
				if not (p.cmd.buttons & BT_JUMP)
					mo.momz = FixedMul(Ray.DIVEREBOUNDCUTMULTIPLIER, $)
				end
				
				-- cut it underwater
				if (mo.eflags & MFE_UNDERWATER)
					mo.momz = FixedMul(FRACUNIT/2, $)
				end
				
				-- set actionstate
				p.actionstate = 0
				B.ResetPlayerProperties(p)
				return
			end
			
			-- stay stuck to the floor
			p.pflags = $|(PF_FULLSTASIS)
			mo.momx, mo.momy = 0, 0
			p.powers[pw_strong] = 0
		end
		
		-- trail and sounds
		if (p.actionstate != st_diveimpact)
			p.drawangle = mo.ray_battle_hangle
			Ray.SpawnSpeedTrail(mo, p.actiontime & 1)	-- combi touches
			if not (p.actiontime % 4)
				P_SpawnGhostMobj(mo)
			end
			mo.ray_battle_stopsound = true
		end
	end
	
	local function ray_battleSpecial(mo, doaction)
		local p = mo.player
		
		-- ability names
		p.actiontext = (mo.state == S_PLAY_GLIDE) and Ray.DIVENAME or Ray.TORNADONAME
		p.actionrings = (mo.state == S_PLAY_GLIDE) and Ray.DIVECOST or Ray.TORNADOCOST
		p.action2text = nil	-- this'll be adjusted
		
		-- start the action
		if (p.actionstate == 0)	-- starting the move?
			if (doaction == 1)	-- just pressed it
				p.glidetime = 0
				p.actionstate = (mo.state != S_PLAY_GLIDE) and st_startup or st_divecircle
				p.actiontime = 0	-- timer for abilities
				p.canguard = false
				B.PayRings(p)
				
				-- reset exhaust and player variables
				p.exhaustmeter = FRACUNIT
				P_ResetPlayer(p)
					
				-- init functions on each state
				if (p.actionstate == st_startup)	-- tornado
					mo.state = S_RAY_TORNADO
					mo.ray_battle_angle = p.drawangle	-- store this
					S_StartSound(mo, sfx_rayspn)
				elseif (p.actionstate == st_divecircle)	-- dive bomb
					-- reset glide
					Ray.ResetGlide(p)
					
					-- store the XY position we started
					mo.ray_battle_start = {
						x = mo.x,
						y = mo.y,
						z = mo.z,
					}
					
					-- get our speed
					mo.ray_battle_speed = FixedHypot(FixedHypot(mo.momx, mo.momy), mo.momz)
					mo.ray_battle_speed = FixedDiv($, Ray.DIVESPEEDDIVIDER)
					mo.ray_battle_speed = max(FixedMul(mo.scale, Ray.DIVEMINSPEED), $)
					
					-- create the circle we'll be following
					local radius = FixedMul(Ray.DIVELOOPSCALAR, mo.ray_battle_speed)
					local circumference = FixedMul(radius * 2, FRACUNIT*157/50)
					
					mo.ray_battle_hangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
					local hangle = mo.ray_battle_hangle
					local zangle = R_PointToAngle2(0, 0, FixedHypot(mo.momx, mo.momy), mo.momz)
					p.drawangle = hangle
					
					mo.ray_battle_circle = {
						radius = radius,	-- we'll use this to create an oval later
						circumference = circumference,	-- we'll use this for approx. later too
						loopspeed = FixedMul(FixedDiv(circumference, mo.ray_battle_speed), TICRATE) / TICRATE,	-- how long it takes to loop the circumference
						x = mo.x + FixedMul(sin(zangle), FixedMul(cos(hangle), -radius)),
						y = mo.y + FixedMul(sin(zangle), FixedMul(sin(hangle), -radius)),
						z = mo.z + FixedMul(cos(zangle), radius),
					}
					local circle = mo.ray_battle_circle
					
					-- start following it
					local circle_hdist = R_PointToDist2(mo.x, mo.y, circle.x, circle.y)
					local circle_zdist = mo.z - circle.z
					
					local targ_zangle = R_PointToAngle2(0, 0, circle_hdist, circle_zdist)
					targ_zangle = (Ray.AngToInt($) + (360 / circle.loopspeed)) % 360 + 1
					local targ_x = circle.x + FixedMul(cos((targ_zangle) * ANG1), FixedMul(cos(hangle), radius))
					local targ_y = circle.y + FixedMul(cos((targ_zangle) * ANG1), FixedMul(sin(hangle), radius))
					local targ_z = circle.z + FixedMul(sin((targ_zangle) * ANG1), radius)
					
					mo.momx = targ_x - mo.x
					mo.momy = targ_y - mo.y
					mo.momz = targ_z - mo.z
					mo.ray_battle_zangle = targ_zangle	-- store this so we can compare next tic
					
					Ray.DustRing(mo)
					S_StartSound(mo, sfx_raybmb)
				end
			end
		else
			if (P_PlayerInPain(p))
			or (p.tumble)	-- GOD
				-- get knocked out of it!
				p.actionstate = 0
				
				-- apply cooldown
				local cooldown = (p.actionstate >= st_startup and p.actionstate <= st_burst) and Ray.TORNADOCOOLDOWN or Ray.DIVECOOLDOWN
				B.ApplyCooldown(p, cooldown)
			else
				-- run actionstate functions
				p.actiontime = $+1
				if (p.actionstate >= st_startup and p.actionstate <= st_burst)
					p.actiontext = Ray.TORNADONAME
					ray_machTornado(mo, doaction)
				elseif (p.actionstate >= st_divecircle and p.actionstate <= st_diveimpact)
					p.actiontext = Ray.DIVENAME
					ray_diveBomb(mo)
				end
			end
		end
		
		-- make sure these reset properly!
		if not (p.actionstate >= st_startup and p.actionstate <= st_burst)
		and (mo.ray_fixstuff)
			S_StopSoundByID(mo, sfx_rayspn)
			mo.flags = $ & ~(MF_NOGRAVITY|MF_BOUNCE)
			B.ResetPlayerProperties(p)
			mo.ray_fixstuff = nil
		end
		
		if (mo.ray_battle_stopsound
		and (p.actionstate < st_divecircle or p.actionstate > st_diveimpact))
			S_StopSoundByID(mo, sfx_raybmb)
			mo.ray_battle_stopsound = nil
		end
	end
	
	-- ray's collision functions
	local function ray_battlePreCollide(s, t, p, mo, atk, def, weight, hurt, pain, ground, angle, thrust, thrust2, collisiontype)
		if not (p[s] and mo[s]) then return end
		
		-- laziness check for hurt value (so we don't have to use 2 different checks...)
		local newhurt = hurt
		if (abs(newhurt) == 1)
		and (s == 2)	-- s is actually t
			newhurt = $ * -1
		end
		
		-- make the tornado continue
		if (p[s].actionstate == st_spin)
		and (newhurt >= 0)
			mo[s].ray_battle_tornadoinfo = {
				nocontrol = p[s].powers[pw_nocontrol],	-- gotta get rid of FLINCHING
				actionstate = p[s].actionstate,
				actiontime = p[s].actiontime,
			}
		end
		
		-- store divebomb momz for collision
		if (p[s].actionstate == st_divebomb)	
			mo[s].ray_divebomb_battlemomz = mo[s].ray_battle_prevmomz
		end
		
		-- cancel certain states
		if p[s].glidetime and mo[s].state == S_PLAY_GLIDE
		and not p[s].climbing
			//Cancel glide
			p[s].pflags = $ &~ PF_NOJUMPDAMAGE
			mo[s].state = S_PLAY_JUMP	-- battle should autocorrect our state
			mo[s].raylandinglag = 2
		end
		
		if (p[s].actionstate >= st_divecircle and p[s].actionstate <= st_divebomb)
			p[s].actionstate = 0
			p[s].pflags = $|(PF_JUMPED)
			mo[s].state = S_PLAY_ROLL
			mo[s].raylandinglag = 2
		end
	end
	
	local function ray_battleCollide(s, t, p, mo, atk, def, weight, hurt, pain, ground, angle, thrust, thrust2, collisiontype)
		if not (p[s] and mo[s]) then return end
		if not (p[t] and mo[t]) then return end
		
		-- invert hurt for easier checks
		if (s == 2 and abs(hurt) == 1)
			hurt = $ * -1
		end
		
		-- make the glide tumble people instead of hurt people
		if (p[s].battle_hurttxt == "skin flaps")
		and (hurt >= 0)	-- just incase, maybe someone could get hit by 0 attack??
			-- check how much attack aether *wouldve* had
			local ray_atk = 0
			if (mo[s].ray_battle_atk)
				ray_atk = mo[s].ray_battle_atk
				
				-- try get sweetspot attack
				if (p[s].battle_sfunc != nil)
					if (CBW_Battle.PriorityFunction[p[s].battle_sfunc](mo[s], mo[t]))
						ray_atk = mo[s].ray_battle_satk
					end
				end
			end
			
			-- try to attack with the glide
			if (ray_atk)
				if (p[t].guard == 1)	-- they're guarding
					S_StartSound(mo[t], sfx_cdpcm9)
					S_StartSound(mo[t], sfx_s259)
					p[t].guard = 2
					p[t].guardtics = 9
					B.ControlThrust(mo[t], FRACUNIT/2)
					
					-- graphical effects
					local sh = P_SpawnMobjFromMobj(mo[t], 0, 0, 0, MT_BATTLESHIELD)
					sh.target = mo[t]
					for n = 0, 16
						local dust = P_SpawnMobj(mo[t].x, mo[t].y, mo[t].z, MT_DUST)
						if (dust and dust.valid)
							P_InstaThrust(dust, mo[t].angle + ANGLE_22h * n, mo[t].scale*36)
						end
					end
					P_SpawnMobjFromMobj(mo[s], 0, 0, 0, MT_EXPLODE)
					
					-- affect source
					if (mo[s].health and p[s].powers[pw_flashing])
						p[s].powers[pw_flashing] = 0
						local nega = P_SpawnMobjFromMobj(mo[s], 0, 0, 0, MT_NEGASHIELD)
						nega.target = mo[s]
					end
					
					-- affect attacker
					if (p[s].powers[pw_invulnerability])
						p[s].powers[pw_invulnerability] = 0
						P_RestoreMusic(p[s])
					end
					
					local angle = R_PointToAngle2(mo[t].x - mo[t].momx, mo[t].y - mo[t].momy, mo[s].x - mo[s].momx, mo[s].y - mo[s].momy)
					local thrust = FRACUNIT*10
					if twodlevel then thrust = B.TwoDFactor($) end
					P_SetObjectMomZ(mo[s], thrust)
					B.DoPlayerTumble(p[s], 45, angle, mo[s].scale * 3, true, true)	-- prevent stunbreak
					return
				elseif (ray_atk > def[t])	-- ray got the hit
					-- tumble them!
					B.DoPlayerTumble(p[t], Ray.GLIDETUMBLETICS)
					P_SetObjectMomZ(mo[t], Ray.GLIDETUMBLEHEIGHT / B.WaterFactor(mo[t]), true)
					return
				end
			end
		end
		
		-- dive bomb spike, just like mighty!
		if (mo[s].ray_divebomb_battlemomz != nil)	-- we got momentum to give em
		and ((hurt >= 1) or pain[t])	-- we gotta hit/trade, or they need to be in pain state (combo them!)
		and (p[s].battle_sfunc != nil and CBW_Battle.PriorityFunction[p[s].battle_sfunc](mo[s], mo[t]))	-- we def got the spike hitbox!
			-- now let's try to spike them!
			if not (ground[t])	-- they need to be airborne
				mo[s].momz = FixedMul(Ray.DIVESPIKEMULTIPLIER, $)
				
				-- send em packin'
				local angle = R_PointToAngle2(mo[s].x, mo[s].y, mo[t].x, mo[t].y)
				P_SetObjectMomZ(mo[t], mo[s].ray_divebomb_battlemomz)
				mo[t].mighty_tumble = 1	-- we'll do some more with this
				S_StartSound(mo[t], sfx_hamspk)
				
				-- cap our momentum
				local modifier = (mighty) and mighty.HammerDropSpikeModifier or Ray.DIVESPIKEMODIFIER
				mo[t].momx = FixedMul(modifier, $)
				mo[t].momy = FixedMul(modifier, $)
				
				-- tumble start stuff (rest will be handled below
				p[t].panim = PA_PAIN
				p[t].pflags = $&~(PF_GLIDING|PF_JUMPED|PF_BOUNCING|PF_SPINNING|PF_THOKKED|PF_SHIELDABILITY)
				
				p[t].tumble = 2
				p[t].tumble_nostunbreak = true
				p[t].airdodge_spin = 0
				if not (p[t].actionsuper) then p[t].actionstate = 0 end
				
				S_StartSound(mo[t], sfx_s3k98)
				//S_StartSoundAtVolume(mo[t], sfx_kc38, 70)	-- this gets prevented, replay below
				return
			end
		end
	end
	
	local function ray_battlePostCollide(s, t, p, mo, atk, def, weight, hurt, pain, ground, angle, thrust, thrust2, collisiontype)
		if not (p[s] and mo[s]) then return end
		if not (p[t] and mo[t]) then return end
		
		-- remove stored vars
		if (mo[s].ray_divebomb_battlemomz != nil)
			mo[s].ray_divebomb_battlemomz = nil
		end
		
		-- mach tornado
		if (mo[s].ray_battle_tornadoinfo)
			local info = mo[s].ray_battle_tornadoinfo
			
			-- get parried!
			if (p[t].guard == 1)	-- they're guarding
				S_StartSound(mo[t], sfx_cdpcm9)
				S_StartSound(mo[t], sfx_s259)
				p[t].guard = 2
				p[t].guardtics = 9
				B.ControlThrust(mo[t], FRACUNIT/2)
				
				-- graphical effects
				local sh = P_SpawnMobjFromMobj(mo[t], 0, 0, 0, MT_BATTLESHIELD)
				sh.target = mo[t]
				for n = 0, 16
					local dust = P_SpawnMobj(mo[t].x, mo[t].y, mo[t].z, MT_DUST)
					if (dust and dust.valid)
						P_InstaThrust(dust, mo[t].angle + ANGLE_22h * n, mo[t].scale*36)
					end
				end
				P_SpawnMobjFromMobj(mo[s], 0, 0, 0, MT_EXPLODE)
				
				-- affect source
				if (mo[s].health and p[s].powers[pw_flashing])
					p[s].powers[pw_flashing] = 0
					local nega = P_SpawnMobjFromMobj(mo[s], 0, 0, 0, MT_NEGASHIELD)
					nega.target = mo[s]
				end
				
				-- affect attacker
				if (p[s].powers[pw_invulnerability])
					p[s].powers[pw_invulnerability] = 0
					P_RestoreMusic(p[s])
				end
				
				local angle = R_PointToAngle2(mo[t].x - mo[t].momx, mo[t].y - mo[t].momy, mo[s].x - mo[s].momx, mo[s].y - mo[s].momy)
				local thrust = FRACUNIT*10
				if twodlevel then thrust = B.TwoDFactor($) end
				P_SetObjectMomZ(mo[s], thrust)
				B.DoPlayerTumble(p[s], 45, angle, mo[s].scale * 3, true, true)	-- prevent stunbreak
			elseif (def[s] > atk[t])
			and (def[s] > def[t])
				-- tumble them
				B.DoPlayerTumble(p[t], Ray.TORNADOCOLLIDETUMBLE)
				P_SetObjectMomZ(mo[t], Ray.TORNADOCOLLIDEHEIGHT / B.WaterFactor(mo[t]), true)
				
				-- push AWAY from them
				local pushback_scalar = FRACUNIT + FixedMul(FixedHypot(mo[s].momx, mo[s].momy), Ray.TORNADOPUSHBACKSCALAR)	-- get weaker depending on how much speed we already have
				local pushback = FixedDiv(Ray.TORNADOPUSHBACK, pushback_scalar)
				P_Thrust(mo[s], angle[s], pushback)
				
				-- restore stuff from before the collision
				p[s].powers[pw_nocontrol] = info["nocontrol"]
				mo[s].recoilangle = nil
				mo[s].recoilthrust = nil
				p[s].actionstate = info["actionstate"]
				p[s].actiontime = info["actiontime"]
			end
			
			-- remove this
			mo[s].ray_battle_tornadoinfo = nil
		end
	end
	
	-- setup ray's skinvars
	S[Ray.SKIN] = {
		weight = 95,
		special = ray_battleSpecial,
		func_priority_ext = ray_battlePriority,
		func_precollide = ray_battlePreCollide,
		func_collide = ray_battleCollide,
		func_postcollide = ray_battlePostCollide,
	}
	
	-- flag to prevent it from being loaded again
	loaded = true
end)

// Button Preventions
Ray.BattleJumpSpecial = function(p)
	if (Ray.IsRay(p))
	and (((p.actionstate)
	and (p.actionstate >= st_startup and p.actionstate <= st_burst))
	or (p.mo and p.mo.raylandinglag))
		return true
	end
end
Ray.BattleSpinSpecial = function(p)
	if (Ray.IsRay(p))
	and (p.actionstate)
	and (p.actionstate >= st_startup and p.actionstate <= st_burst)
		return true
	end
end

-- mighty's perma-tumble, stolen just for ray!
Ray.DiveBombBattleTumble = function()
	if (chaotix) then return end	-- no need, this'll do it for us
	if not (CBW_Battle) then return end	-- battle isnt loaded
	local B = CBW_Battle
	
	for p in players.iterate
		local mo = p.mo
		if not ((mo and mo.valid) and mo.health) then continue end
		if not (mo.mighty_tumble) then continue end
		
		-- pretty nasty hack, but tumble isnt usually consistently this low
		if (p.tumble and p.tumble > 6)
			-- assume a new tumble has been established
			mo.mighty_tumble = nil
			mo.mighty_tumble_sound = nil
			mo.mighty_tumble_bounces = nil
			mo.mighty_tumble_flashingfreeze = nil
			continue
		end
		
		-- register the bounces on the ground
		if (P_IsObjectOnGround(mo))
			mo.mighty_tumble_bounces = $ and $+1 or 1
		end
		
		-- end the bouncing (doing the check like this to conquer load order)
		local bounces = mo.mighty_tumble_bounces or 0
		
		if (((mo.momz * P_MobjFlip(mo)) > 0) and (bounces >= Ray.DIVESPIKEBOUNCES))
		or (mo.mighty_tumble >= Ray.DIVESPIKEMAXTICS)
			mo.mighty_tumble = nil
			mo.mighty_tumble_sound = nil
			mo.mighty_tumble_bounces = nil
			
			-- we'll have to reset it ourself
			if (mo.mighty_tumble_flashingfreeze)
				p.powers[pw_flashing] = (3*TICRATE) - 1
				mo.mighty_tumble_flashingfreeze = nil
			end
				
			-- might as well end the tumble ourself
			p.tumble = nil
			p.lockmove = false
			p.drawangle = mo.angle
			S_StopSoundByID(mo, sfx_kc38)
			B.ResetPlayerProperties(p, false, false)
			
			-- go into falling animation
			p.panim = PA_FALL
			mo.state = S_PLAY_FALL
				
			-- don't do anything else
			continue
		end
		
		-- start the sound up again
		if not (mo.mighty_tumble_sound)
			mo.mighty_tumble_sound = true
			S_StartSoundAtVolume(mo, sfx_kc38, 70)
		end
		
		-- perma-tumble (while keeping the effects working)
		if (p.tumble == nil)
		or (p.tumble <= 2)
			p.tumble = 6	-- reset to 6 so the tumble afterimage is still spawned
			p.tumble_nostunbreak = true
		end
		
		-- nasty hack so invuln period is correctly applied
		if (P_PlayerInPain(p) and (p.powers[pw_flashing] == 3*TICRATE))
			mo.mighty_tumble_flashingfreeze = true
		end
		if (mo.mighty_tumble_flashingfreeze) then p.powers[pw_flashing] = (3*TICRATE) - 1 end	-- gotta keep it one below so tumble doesnt get ended early
		
		-- increase tumble tics
		mo.mighty_tumble = $+1
	end
end