-- rayinvert command

-- get defaults from I/O (player 2 is in the same file)
local default1 = "Off"
local default2 = "Off"
local file = io.openlocal("client/Ray/Invert.dat")
if file
	local num = file:read("*n")
	if num
		if num & EMERALD1 then default1 = "On" end
		if num & EMERALD2 then default2 = "On" end
	end
	file:close()
end

-- function to save to I/O when the command is modified
Ray.InvertFunc = function()
	local file = io.openlocal("client/Ray/Invert.dat", "w+")
	
	local num = 0
	if Ray.Invert1.value then num = $ | EMERALD1 end
	if Ray.Invert2.value then num = $ | EMERALD2 end
	
	file:write(num)
	file:close()
end

-- player 1's command
Ray.Invert1 = CV_RegisterVar({
	name = "rayinvert",
	defaultvalue = default1,
	flags = CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = Ray.InvertFunc
})

-- player 2's command
Ray.Invert2 = CV_RegisterVar({
	name = "rayinvert2",
	defaultvalue = default2,
	flags = CV_CALL|CV_NOINIT,
	PossibleValue = CV_OnOff,
	func = Ray.InvertFunc
})

-- locally invert forwardmove during a glide, or when starting one
Ray.PlayerCmd = function(player, cmd)
	if not Ray.IsRay(player) or Ray.CantMove(player)
	or not (cmd.buttons & BT_JUMP) or player.climbing
	or not ((Ray.Invert1.value and player == consoleplayer)
	or (Ray.Invert2.value and player == secondarydisplayplayer))
		return
	end
	
	if player.rayglidethrust
	or ((player.pflags & (PF_JUMPED|PF_JUMPDOWN|PF_STARTJUMP|PF_JUMPSTASIS|PF_SLIDING)) == PF_JUMPED
	and (not (player.pflags & PF_THOKKED) or player.charflags & SF_MULTIABILITY))
		cmd.forwardmove = -$
	end
end