-- 2 different hang sprites, selected at random!
Ray.AltHangChance = FRACUNIT/2

local function ray_resetHang(mo)
	mo.ray_hang_state = nil
	mo.ray_hang_alt = nil
end

Ray.HangThinker = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	-- reset conditions
	if not Ray.IsRay(p) or (mo.sprite2 != SPR2_RIDE
	and not (mo.ray_hang_alt and mo.sprite2 == SPR2_BNCE))
		ray_resetHang(mo)
		return
	end
	
	-- set some vars
	if (mo.ray_hang_state == nil)
		mo.ray_hang_state = mo.state
		mo.ray_hang_alt = P_RandomChance(Ray.AltHangChance) 
	end
	
	-- cancel hang if we enter a different state
	if (mo.state != mo.ray_hang_state)
		ray_resetHang(mo)
		return
	end
	
	-- set the alt hang sprite
	if (not mo.ray_hang_alt) then return end
	mo.frame = $ &~ FF_FRAMEMASK
	mo.sprite2 = SPR2_BNCE
end