//Ray Memes

freeslot("S_RAY_UGLY", "S_RAY_UGLY_AIR", "sfx_rayugl", "S_RAY_VICTORY")
sfxinfo[sfx_rayugl].caption = "You're ugly."

//Ugly
function A_Ray_Ugly(mo, var1, var2)
	local player = mo and mo.valid and mo.player
	if not player then return end
	
	player.panim = P_IsObjectOnGround(mo) and var1 or var2
end
states[S_RAY_UGLY] = {SPR_PLAY, SPR2_TAL4, 4, A_Ray_Ugly, PA_IDLE, PA_FALL, S_RAY_UGLY}
states[S_RAY_UGLY_AIR] = {SPR_PLAY, SPR2_TAL5, 4, A_Ray_Ugly, PA_IDLE, PA_FALL, S_RAY_UGLY_AIR}

Ray.UglyThinker = function(player)
	local mo = player.mo
	if not (mo and mo.valid) then return end
	
	if (mo.state == S_RAY_UGLY or mo.state == S_RAY_UGLY_AIR)
	and not Ray.IsRay(player)
		mo.state = P_IsObjectOnGround(mo) and S_PLAY_STND or S_PLAY_FALL
	elseif mo.uglyspark and mo.uglyspark.valid
	and not (mo.state == S_RAY_UGLY or mo.state == S_RAY_UGLY_AIR)
		P_RemoveMobj(mo.uglyspark)
		mo.uglyspark = nil
	end
end

//Victory
Ray.VictorySPR2 = SPR2_TAL3
Ray.VictoryThemeStart = "rayvc1"
Ray.VictoryThemeLoop = "rayvc2"
Ray.VictoryBPM = 128
Ray.VictoryFlipPoint = G
Ray.VictoryMoveSpeed = FRACUNIT*6
states[S_RAY_VICTORY] = {SPR_PLAY, Ray.VictorySPR2, 1, nil, 0, 0, S_RAY_VICTORY}

-- sync up to the NEXT frame (it's confusing but trust me)
Ray.VictoryFrameSpeeds = {
	[C] = FRACUNIT/3,
	[F] = FRACUNIT*5/4,
	[H] = -(FRACUNIT*2/3),
	[I] = -(FRACUNIT/2),
	[K] = FRACUNIT*4/3,
	[L] = FRACUNIT*3/2,
}

-- gotta use a thinkframe func because cmd wasnt picked up?
Ray.ResetVictory = function(p)
	p.ray_victory = nil
	p.ray_victory_start = nil
	p.ray_victory_timer = nil
	p.ray_victory_automove = nil
	p.ray_victory_moveinfo = nil
	p.ray_victory_frame = nil
	p.ray_victory_flipped = nil
	p.ray_victory_life = nil
end
	
Ray.VictoryThinker = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
	
	if not (p.ray_victory) then Ray.ResetVictory(p) return end
	
	if not (Ray.IsRay(p))
	or (mo.state != S_RAY_VICTORY)
		if (mo.state == S_RAY_VICTORY)
			mo.state = P_IsObjectOnGround(mo) and S_PLAY_STND or S_PLAY_FALL
		end
		
		Ray.ResetVictory(p)
		return
	end
	
	-- hack to stop the music when victory stops or when you get a 1up
	if (p.ray_victory_life)
		if p.powers[pw_extralife] > 2
			p.ray_victory_life = false
		else
			p.powers[pw_extralife] = max($, 2)
		end
	end
	
	-- hack to prevent automatic camera movement
	p.powers[pw_justsprung] = min($, 2)
	if not P_GetPlayerControlDirection(p)
	and p.pflags & PF_DIRECTIONCHAR and p.pflags & PF_ANALOGMODE
		mo.angle = p.cmd.angleturn << 16
	end
	
	-- get player angle and frame
	local angleturn = p.cmd.angleturn << 16
	local angle = angleturn - (p.ray_victory_flipped and ANGLE_270 or ANGLE_90)
	local frame = 1
	
	if not (p.ray_victory_start)
		-- start the victory
		if (P_IsObjectOnGround(mo))
			p.ray_victory_start = true
			p.ray_victory_timer = 1
			p.ray_victory_automove = true
			P_PlayJingleMusic(p, Ray.VictoryThemeLoop, 0, true, JT_1UP)
		end
	else
		local frames = skins[p.skin].sprites[Ray.VictorySPR2].numframes
		local beats_per_animloop = 4	-- how many beats per animation loop
		local bpm = FixedDiv((60*TICRATE)<<FRACBITS, Ray.VictoryBPM << FRACBITS)
		local curtics = p.ray_victory_timer
		
		local work = (curtics << FRACBITS) % (bpm * beats_per_animloop)
		if (curtics >= (FRACUNIT >> 1)) then p.ray_victory_timer = (work >> FRACBITS) end
		
		work = FixedDiv(work * frames, bpm * beats_per_animloop)
		frame = work / FRACUNIT
		p.ray_victory_timer = $+1
		
		-- register movement on beat
		if not (frame % (frames / beats_per_animloop))
			p.ray_victory_automove = P_IsObjectOnGround(mo)
				
			local moveinfo
			if (p.cmd.forwardmove or p.cmd.sidemove)
			and (P_IsObjectOnGround(mo))
				moveinfo = {}
					
				-- get speed
				local strength = FixedHypot(p.cmd.forwardmove*FRACUNIT, -(p.cmd.sidemove*FRACUNIT))
				moveinfo["speed"] = FixedDiv(FixedMul(strength, Ray.VictoryMoveSpeed), FRACUNIT*50)
					
				-- get angle
				local controlangle = R_PointToAngle2(0, 0, p.cmd.forwardmove * FRACUNIT, -(p.cmd.sidemove * FRACUNIT))
				moveinfo["angle"] = angleturn + controlangle
			end
			p.ray_victory_moveinfo = moveinfo
		end
		
		-- auto correct this var
		if (P_IsObjectOnGround(mo))
		and not (p.ray_victory_automove)
			p.ray_victory_automove = true
		end
		
		-- frame specific behaviour
		local old_frame = p.ray_victory_frame
		if (old_frame == nil or old_frame != frame)
		and (frame == Ray.VictoryFlipPoint)
			-- flip and recalculate angle
			p.ray_victory_flipped = not $
			angle = angleturn - (p.ray_victory_flipped and ANGLE_270 or ANGLE_90)
		end
		p.ray_victory_frame = frame	-- store frame for comparisons
		
		-- move about on the ground
		if (p.ray_victory_automove)	-- it all extends from this
			local speed = Ray.VictoryFrameSpeeds[frame] or 0
			P_InstaThrust(mo, angle, FixedMul(mo.scale, speed))
			
			-- add additional movement from the player's input
			if (p.ray_victory_moveinfo != nil)
			and (frame % (frames / beats_per_animloop))
				local moveinfo = p.ray_victory_moveinfo
				
				local speed_modifier = (((frames / beats_per_animloop) - (frame % (frames / beats_per_animloop))) * FRACUNIT) / ((frames / beats_per_animloop) - 1)	-- yes ik this line is aids
				local move_speed = FixedMul(speed_modifier, moveinfo["speed"])
				
				if (mo.eflags & MFE_UNDERWATER)
					local underwater_modifier = FRACUNIT*2/3
					move_speed = FixedMul(underwater_modifier, $)
				end
				P_Thrust(mo, moveinfo["angle"], FixedMul(mo.scale, move_speed))
			end
			
			-- add back conveyor momentum
			if (P_IsObjectOnGround(mo))
				mo.momx = $ + p.cmomx
				mo.momy = $ + p.cmomy
			end
		end
	end
	
	-- set frame and angle
	p.drawangle = angle
	p.panim = P_IsObjectOnGround(mo) and states[mo.state].var1 or states[mo.state].var2
	mo.frame = ($ &~ FF_FRAMEMASK) | frame
end
states[S_RAY_VICTORY] = {SPR_PLAY, SPR2_TAL3, -1, nil, PA_ETC, PA_DASH, S_RAY_VICTORY}

//Activation
addHook("PlayerMsg", function(player, msgtype, target, msg)
	if (msgtype) then return end	-- needs to be a regular message
	
	-- mobj checks
	local mo = player.mo
	if not (Ray.IsRay(player) and mo.health) then return end	-- gotta be alive and ray
	
	-- both state checks
	if (mo.state == S_RAY_UGLY or mo.state == S_RAY_UGLY_AIR
	or mo.state == S_RAY_VICTORY)	-- already doing it
	or (player.actionstate)	-- actionstate
	or (player.isjettysyn)	-- NO
	or (player.powers[pw_nocontrol])	-- no control
		return
	end
	
	-- check message
	msg = $:lower()
	if (msg == "ugly" or msg == "victory")
		local panim, state
		
		if (P_IsObjectOnGround(mo))
			-- fail conditions
			if (player.speed) then return end	-- can't be moving!
			
			-- start the grounded ugly
			state = S_RAY_UGLY
			player.pflags = $ & ~(PF_SPINNING|PF_STARTDASH)
		else
			-- fail conditions
			if (mo.state == S_PLAY_GLIDE)	-- specific check for the gliding
			or (P_PlayerInPain(player))	-- we got hurt
			or (player.powers[pw_carry])	-- we got carried
			or (player.panim == PA_PAIN)	-- pain pain pain pain pain
			or (player.airdodge) 	-- air dodging
			or (player.climbing)	-- climbing
				return 
			end
			
			-- start the aerial ugly
			state = S_RAY_UGLY_AIR
			player.pflags = $ & ~(PF_JUMPED|PF_STARTJUMP|PF_SPINNING)
		end
		
		-- hijack ugly, victory time
		if msg == "victory"
			-- set state
			player.panim = P_IsObjectOnGround(mo) and states[mo.state].var1 or states[mo.state].var2
			player.ray_victory = true
			mo.state = S_RAY_VICTORY
			
			-- anim stuff
			player.ray_victory_timer = 1
			player.ray_victory_flipped = false
			player.drawangle = mo.angle - ANGLE_90
			if not (P_IsObjectOnGround(mo))
				-- fix up frame in the air
				mo.frame = ($ &~ FF_FRAMEMASK) | 1
			end
			
			-- start the music
			player.ray_victory_start = P_IsObjectOnGround(mo)
			P_PlayJingleMusic(player, player.ray_victory_start
			and Ray.VictoryThemeLoop or Ray.VictoryThemeStart, 0, true, JT_1UP)
			
			-- setup hackery
			player.powers[pw_extralife] = 2
			player.ray_victory_life = true
			return true
		end
		
		-- we got ugly
		local spark = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
		spark.state = S_NIGHTSPARKLE1
		spark.tics = 7
		spark.target = mo
		spark.spritexoffset = FRACUNIT*-3
		spark.spriteyoffset = FRACUNIT*28
		
		mo.uglyspark = spark
		S_StartSound(mo, sfx_rayugl)
		
		if (mo.state != state) then mo.state = state end
		return true
	end
end)

//Shoe stuff

Ray.ShoesDeathChance = FRACUNIT/8
Ray.ShoesDeathThreshold = -7*FRACUNIT
Ray.ShoesDeathStall = 6

A_RayShoes = function(mo)
	if not ((mo and mo.valid) and mo.health) then return end
	
	-- target validity checks
	local target = mo.target
	
	if not (target and target.valid)	-- target doesn't exist
	or (target.health)	-- they revived??
	or (target.skin != Ray.SKIN)	-- we are no longer ray
		P_RemoveMobj(mo)
		return
	end
	
	-- adjust to target's colour and sprite2
	mo.color = target.color
	mo.sprite2 = mo.threshold | (target.sprite2 & FF_SPR2SUPER)
	
	-- change rollangle
	local angle = ANGLE_22h
	if mo.reactiontime > 1 then angle = -$ end
	mo.rollangle = $ + angle
end
freeslot("S_RAY_SHOES")
states[S_RAY_SHOES] = {SPR_PLAY, SPR2_TAL1, 1, A_RayShoes, 0, 0, S_RAY_SHOES}

-- ray's shoes can pop off when you fall in a pit!
addHook("MobjDeath", function(mo, inflictor, source, damagetype)
	if (mo.skin != Ray.SKIN) then return end
	if (damagetype != DMG_DEATHPIT) then return end
	
	-- random chance to have our shoes pop off
	if (P_RandomChance(Ray.ShoesDeathChance))
		mo.ray_shoesdeath = 1
	end
end, MT_PLAYER)

Ray.ShoesDeathThinker = function(player)
	local mo = player.mo
	if not (mo and mo.valid) then return end
	
	-- check if should have our shoes pop off!
	if not (mo.ray_shoesdeath) then return end
	if (mo.health)	-- we're alive???
	or (mo.skin != Ray.SKIN)	-- we are somehow not ray anymore
	or (player.isjettysyn)	-- NO
		mo.ray_shoesdeath = nil
		return
	end
	
	-- pop the shoes off!
	local threshold = FixedMul(mo.scale, Ray.ShoesDeathThreshold)
	if ((mo.momz * P_MobjFlip(mo)) < threshold)	-- we're falling fast enough
	and (mo.ray_shoesdeath != 2)	-- we haven't already done the pop
		-- spawn the shoes
		for i = 1, 2
			local shoe = P_SpawnMobjFromMobj(mo, 0,0,0, MT_GHOST)
			shoe.target = mo
			shoe.skin = mo.skin
			shoe.color = mo.color
			shoe.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
			
			local angle = player.cmd.angleturn<<16
			shoe.angle = angle
			
			local thrust = mo.scale
			if i > 1 then thrust = -$ end
			angle = $ + ANGLE_90
			P_InstaThrust(shoe, angle, thrust)
			shoe.momz = mo.momz/-2
			
			if i <= 1
				shoe.spritexoffset = 16*FRACUNIT
				shoe.spriteyoffset = 8*FRACUNIT
			else
				shoe.spritexoffset = -15*FRACUNIT
				shoe.spriteyoffset = 2*FRACUNIT
			end
			shoe.reactiontime = i
			shoe.threshold = SPR2_TAL0 + i
			shoe.state = S_RAY_SHOES
			shoe.dispoffset = 1
			
			local explode = P_SpawnMobjFromMobj(shoe, 0,0,0, MT_EXPLODE)
			explode.spritexoffset = shoe.spritexoffset
			explode.spriteyoffset = shoe.spriteyoffset
			explode.dispoffset = 2
		end
		S_StartSound(mo, sfx_cdfm15)
		mo.state = S_TAILSOVERLAY_STAND
		
		-- set this so we don't do this again
		mo.ray_shoesdeath = 2	
	end
end